#ifndef MAINCLASS_HH
# define MAINCLASS_HH
# include <vector>
# include <memory>
class MainClass
{
  public:
    MainClass(int argc, char* argv[]);

    int usage();
    int execute();

    static int get_current_device();
    static int set_current_device(int c);

    static uint8_t get_pins();
    static uint8_t up_pin(uint8_t pin);
    static uint8_t down_pin(uint8_t pin);

  private:
    bool build_actions_();
    bool bad_value_();
    int argc_;
    char** argv_;
    std::vector<std::function<bool()>> actions_;

    static int current_device_;
    static uint8_t pins_;
};
#endif /* !MAINCLASS_HH */
